// CustomEdit.cpp : implementation file
//

#include "stdafx.h"
#include "CustomEdit.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//DEFINES
//
#define FLUSH_BUFFER_TIMER 1

/////////////////////////////////////////////////////////////////////////////
// CCustomEdit

CCustomEdit::CCustomEdit()
{
	m_totalLines = 50000;// Total lines in edit box
	m_deleteLines = 20;//lines to be deleted from the start 
	m_currentBufferPosition = 0;
	m_stop_comm = FALSE;
}

CCustomEdit::~CCustomEdit()
{

}

void CCustomEdit::Add_line(LPCTSTR lpsz)
{
	static BOOL ShouldCreateTimer = TRUE;

	if((this->m_hWnd == NULL) || (m_stop_comm))
		return;
	
	if (ShouldCreateTimer)
	{
		ShouldCreateTimer = FALSE;
		SetTimer(FLUSH_BUFFER_TIMER,250,NULL);
		SetLimitText(262144);
	}


	//Checking if I need to flush the buffer
	if (m_currentBufferPosition+strlen(lpsz)>BUFFER_SIZE)
		FlushBuffer();

	//Doing wrap around if maximum number of lines is exceeded
	if (GetLineCount() >= (m_totalLines-1))
	{
		SetSel(0, LineIndex(m_deleteLines), TRUE/*bNoScroll*/);  // select the first line
		Clear();  // and remove it
	}
	
	_stprintf(m_szt+m_currentBufferPosition, _T("%s"), lpsz);
	m_currentBufferPosition+=strlen(lpsz);

}

BEGIN_MESSAGE_MAP(CCustomEdit, CEdit)
	//{{AFX_MSG_MAP(CCustomEdit)
	ON_WM_CHAR()
	ON_WM_SETFOCUS()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_MESSAGE(EM_SCROLLCARET, OnScrollCaret)
	ON_WM_TIMER()
	ON_CONTROL_REFLECT(EN_HSCROLL, OnHscroll)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomEdit message handlers

//clears all the text in the edit box
void CCustomEdit::Clear_all()
{
	SetSel(0,LineIndex(m_totalLines), TRUE/*bNoScroll*/);
	Clear();  
}

void CCustomEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	//Does nothing on purpose and overides the default implementation
	//in order to make a semi-readonly edit.

}

void CCustomEdit::OnScrollCaret(WPARAM wParam, LPARAM lParam)
{
	//Do nothing
}

void CCustomEdit::OnSetFocus(CWnd* pOldWnd) 
{
	//Do not delete this (empty) function.
	//The reason it is here is to prevent the
	//user from selecting any portions of the 
	//control.
}


void CCustomEdit::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//Do not delete this (empty) function.
	//The reason it is here is to prevent the
	//user from selecting any portions of the 
	//control.
}


void CCustomEdit::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	//Do not delete this (empty) function.
	//The reason it is here is to prevent the
	//user from selecting any portions of the 
	//control.
}

void CCustomEdit::FlushBuffer()
{
	int		nStartChar,nEndChar;


	//Reseting position of buffer
	m_currentBufferPosition = 0;

	//Setting the selection at the end of the text and
	//replacing it.
	SetSel(LineIndex(GetLineCount()),GetLimitText(),TRUE);
	GetSel(nStartChar,nEndChar);
	SetSel(nEndChar,nEndChar,TRUE);

	this->SetRedraw(FALSE);
	ReplaceSel(m_szt);
	this->SetRedraw(TRUE);
	this->SendMessage(WM_VSCROLL,(GetScrollLimit(SB_VERT)<<16)| SB_THUMBPOSITION,NULL);

}


void CCustomEdit::OnTimer(UINT nIDEvent) 
{
	switch (nIDEvent)
	{
	case FLUSH_BUFFER_TIMER:
		if (m_currentBufferPosition)
			FlushBuffer();
		break;
	}
	CEdit::OnTimer(nIDEvent);
}


void CCustomEdit::OnHscroll() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CEdit::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_SCROLL flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	
}

void CCustomEdit::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CEdit::OnHScroll(nSBCode, nPos, pScrollBar);
}

CScrollBar* CCustomEdit::GetScrollBarCtrl(int nBar) const
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CEdit::GetScrollBarCtrl(nBar);
}

BOOL CCustomEdit::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CEdit::OnCommand(wParam, lParam);
}

