//-------------------------------------------------------------------------
// (C) ESHED ROBOTEC (1982) LTD.         
//
//
// Written & designed by Dimo L. Vasilenko.     Modified by Shimon 21-aug-2003
// Created 04.04.94
//
// VC2_FUNS.CPP
//-------------------------------------------------------------------------

#include "stdafx.h"
//#include <dos.h>
#include <assert.h>
#include <stdio.h>
#include <time.h>
#include <ctype.h>
//#include <sys\types.h>
//#include <owl\applicat.h>
//#include <bwcc.h>
#include <direct.h>
#include <string.h>

#include  "cim_dde.h"
#include  "vc2_funs.h"
//#include  "dvfun.h"
#include  "vc2_typs.h"
#include  <io.h>
#include <fstream.h>

//--- external variable
// extern char st[];


extern void fnmerge(char *szCimSetupPath,char* drive, char* dir, 
						 char*file, char* ext );
extern void fnsplit(char *szCimSetupPath,char* drive, char* dir, 
						 char*file, char* ext );
long HundredthsOfSeconds( CTime t);

//--------------------------------------------------------------------------
// The Function moves Window to Center of the screen
//--------------------------------------------------------------------------
void WindowToCenter( HWND& hWindowToCenter )
{
RECT rect;

GetWindowRect(hWindowToCenter,&rect);
int sw = GetSystemMetrics(SM_CXSCREEN);
int sh = GetSystemMetrics(SM_CYSCREEN);
int x = (sw/2)-((rect.right-rect.left)/2);
int y = (sh/2)-((rect.bottom-rect.top)/2);
SetWindowPos(hWindowToCenter,HWND_TOP,x,y,0,0,SWP_NOSIZE | SWP_NOZORDER);
/*
RECT r;
RECT desktopRect;
RECT windowRect;
GetWindowRect( GetDesktopWindow(), &desktopRect );
GetWindowRect( hWindowToCenter, &windowRect );
r.right = (int)(desktopRect.right-desktopRect.left-windowRect.right+windowRect.left)/2;
r.top = (int)(desktopRect.bottom-desktopRect.top-windowRect.bottom+windowRect.top)/2;
r.left = windowRect.right-windowRect.left;
r.bottom = windowRect.bottom-windowRect.top;
SetWindowPos( hWindowToCenter, (HWND)NULL, r.right, r.top, r.left, r.bottom, SWP_SHOWWINDOW );
*/
}


//--------------------------------------------------------------------------
// The Function makes Windows to sleep
//--------------------------------------------------------------------------
void WindowsSleep( unsigned milliseconds, BOOL hourglass )
{
HCURSOR OldCur;
//--- set the cursor to an hourglass - this might take awhile ---
if( hourglass ) OldCur = SetCursor( LoadCursor( 0, IDC_WAIT ) );
long diff = (long)milliseconds / 10;
//struct time tFirst, tNext;

//gettime(&tFirst);
CTime tFirst=CTime::GetCurrentTime();
CTime tNext;

long lFirst = HundredthsOfSeconds( tFirst  );
while( TRUE )
	{
	//gettime(&tNext);
	tNext=CTime::GetCurrentTime();
	if( HundredthsOfSeconds( tNext ) - lFirst > diff ) break; // narrow place on the midnight
	}
if( hourglass ) SetCursor( OldCur );
}

//--------------------------------------------------------------------------
// The Function returns hundredths of seconds( struct time& t )
//--------------------------------------------------------------------------
long HundredthsOfSeconds( CTime t)//struct time_t& t )
{

//return((long)t.ti_hour*60*60*100 + 
//			 (long)t.ti_min*60*100 + 
//			 (long)t.ti_sec*100 + 
//			 (long)t.ti_hund);
	return ((long)t.GetHour()*60*60*100+
		      (long)t.GetMinute()*60*100+
					(long)t.GetSecond()*100);
}

//--------------------------------------------------------------------------
// The Function returns hundredths of seconds
//--------------------------------------------------------------------------
long HundredthsOfSeconds()
{
//struct time t;
//gettime(&t);
	CTime t=CTime::GetCurrentTime();
return HundredthsOfSeconds(t);
}

//-----------------------------------------------------------------
// Communication Error
//-----------------------------------------------------------------
void CommError( int err, int com )
{
char st[80];
char errstr[50] = "";
switch(err)
	{
	case IE_HARDWARE : strcpy(errstr, "hardware's not available!");
							 break;
	case IE_OPEN : 	 strcpy(errstr, "device is already open!");
							 break;
	}
sprintf(st, "Unable to open COM%d communication port:\n %s", com, errstr);
::MessageBox( NULL, st, "Communication error", MB_OK | MB_ICONSTOP );
}

char *_sably (int pr,char *str)
{
int     i,j,k;

j=strlen(str);
switch (pr)
{   case 0:     for (i=0;i<j && str[i]==' ';++i) ;
					 for (k=0;k<=j;++k,++i) str[k]=str[i];
					 break;
	 case 1:     for (i=j-1;i>=0 && str[i]==' ';--i)  str[i]=0;
					 break;
	 case 2:	_sably(0,str);
		_sably(1,str);
		break;
}
return str;
}




//MMR

void GetSubString(LPSTR mString, LPSTR mTargetStr, int mPos){
  int				index;
	int				step;
	int				start;	
	CString		temps; 
	

	temps=mString;
  //while(temps.GetLength()>0 && 
	//	     temps.GetAt(0)==' '){
   // temps=temps.Mid(1);
	//}


	index=temps.Find(" ",1);
	step=1;
	start=0;
	while(index>0 && step!=mPos){
    start=index+1;
		//while(temps.GetLength()>0 && temps.GetAt(0)==' '){
			index=temps.Find(" ",start);
    //  temps=temps.Mid(1);
		//}
		step++;
	}

	if(index==-1)
		index=temps.GetLength();

	if(step==mPos)
      temps=temps.Mid(start,index-start);
	else
		temps="0";


	strcpy(mTargetStr,(LPSTR)(LPCTSTR)temps);
}


//MMR
BOOL ThisIsRobot(int mID,char *SetupCimPath){  
  char				inbuf[120];
	char				tempID[5];
	char				tempType[2];
	int					mIdint;

	::ifstream inf(SetupCimPath);	                 // Shimon
	while(inf){
		inf.getline(inbuf,120);
    GetSubString(inbuf,tempID,1);    
		GetSubString(inbuf,tempType,5);
    mIdint=atoi(tempID);
		if(mIdint==mID && strcmp(tempType,"R")==0)
			return TRUE;
	}

   return FALSE; 
}





//------------------------------------------------------------------
// void CommaParserStr2IntArray()
// parsers character string represented in the "1,2,3" form into
// integer array [1][2][3].
//
// the reason to write this function is following:
// "If the "leader developers" have no clear understanding what
// the system they are developing is, they make problems for others"
// so the task i was working was the next: load a driver with command
// line parameters. one of them was ID of logical device. That ID
// was used in dde module to recognize if the dde message was for
// that driver. later it was need to add new features to
// the technology: driver may receive not an only ID but set of ID's.
// splendid ! but that ID is THE LOGICAL ID ! and everybody knows that
// logical(more exactly any) object may have aliases! the simple way
// to solve the task is to load driver with an only ID and to realize
// in the technology manager that that ID has aliases. but not!
// they think that task is the driver task! have you seen something
// like that before ? ok let's go back to programming ...
//------------------------------------------------------------------
/*mmr 
void CommaParserStr2IntArray( char *str, int *array, unsigned size )
{
char *p1 = str;
char *p2 = p1;
char buffer[10];
UINT i = 0;

while( (*p1) != '\0' )
	{
	p1++;
	if((*p1) == ',' )
		{
		(*p1) = '\0';
		strcpy( buffer, p2 );
		if( i < size )
			array[i] = atoi(buffer);
		(*p1) = ',';
		p2 = p1+1;
		++i;
		}
	else if  ((*p1) == '\0' )
		{
		strcpy( buffer, p2 );
		if( i < size )
			array[i] = atoi(buffer);
		break;
		}
	}
return;
}


*/

void CommaParserStr2IntArray( char *str, int *array, unsigned size, char *SetupPath){
	char *p1 = str;
	char *p2 = p1;
	char buffer[10];
  char SetupCimPath[MAXPATH];
	int  tempElement;
  
	strcpy(SetupCimPath,SetupPath);
	strcat(SetupCimPath,"Setup.cim");

	UINT i = 0;
	UINT j;

	while( (*p1) != '\0' ){
		p1++;
		if((*p1) == ',' ){
			(*p1) = '\0';
			strcpy( buffer, p2 );
			if( i < size )
				array[i] = atoi(buffer);
			(*p1) = ',';
			p2 = p1+1;
			++i;
		}
		else if  ((*p1) == '\0' ){
			strcpy( buffer, p2 );
			if( i < size )
				array[i] = atoi(buffer);
			break;
		}
	}
  
	j=0;
  while(j<=i){
		if(ThisIsRobot(array[j],SetupCimPath)==TRUE){
			tempElement=array[0];
			array[0]=array[j];
			array[j]=tempElement;
		}
    j++;  
	}

	return;
}


BOOL IsItemInArray( int item, int *array, unsigned size )
{
for( UINT i = 0; i < size; ++i )
	{
	if( array[i] == item ) return TRUE;
	}
return FALSE;
}

//-------------------------------------------------------------------
// int IsDirCurrent( int argc, char *argv[], char *cHomeDir )
//-------------------------------------------------------------------
int IsDirCurrent( int argc, CString argv[], char *cHomeDir )
{
char szBuffer[MAXDIR];
int iStatus = 0;
char *p;

for( int i = 0; i < argc; ++i )
	{
	strupr( (LPSTR)(LPCTSTR)argv[i] );
	if( strstr( (LPSTR)(LPCTSTR)argv[i], "/C:" ) != NULL ) {
		iStatus = 1;
		p = strchr( (LPSTR)(LPCTSTR)argv[i], ':' );
		strcpy( szBuffer, ++p );
		break;
		}
	if( strcmp( (LPSTR)(LPCTSTR)argv[i], "/C" ) == 0 ) {
		iStatus = 2; break;
		}
	}

_getcwd( cHomeDir, MAXPATH );
AddSlash( cHomeDir );
if( iStatus == 1 ) {
	strcat( cHomeDir, szBuffer );
	}
AddSlash( cHomeDir );
return iStatus;
}

// char * AddSlash( char *s )
char * AddSlash( char *s )
{
int i = strlen( s );
if( s[i-1] != '\\' ) {
	s[i] = '\\';
	s[i+1] = '\0';
	}
return s;
}

BOOL IsFastDebugMode( int argc, CString argv[],
							 BOOL& aFastDebugMode,
							 long& aFastDebugDelay )
{
for( int i = 0; i < argc; ++i )
	{
	strupr( (LPSTR)(LPCTSTR)argv[i] );
	if( strstr( (LPSTR)(LPCTSTR)argv[i], "/SIMULATION" ) != NULL )
		{
		aFastDebugDelay = 1000; // 1 second
		aFastDebugMode = TRUE;
		char *p = strchr( (LPSTR)(LPCTSTR)argv[i], ':' );
		if( p != NULL )
			aFastDebugDelay = atol( ++p );
		return TRUE;
		}
	}
aFastDebugMode = FALSE;
return FALSE;
}


//-------------------------------------------------------------------
// void _getcwd (char *buff)
//-------------------------------------------------------------------
/*
void _getcwd (char *buff)
{
char	i;

getcwd( buff, MAXPATH );
i = strlen( buff );
if( buff[i-1] != '\\' )  {
	buff[i] = '\\';
	buff[i+1] ='\0';
	}
}
*/

//-------------------------------------------------------------------
// int GetDDENumber( char *szItem )
//-------------------------------------------------------------------
int GetDDENumber( char *szItem )
{
if( strcmp( szItem, DDE_CIMITEM )  == 0 ) return DDE_CIM;
if( strcmp( szItem, DDE_OLMTITEM ) == 0 ) return DDE_OLMT;
if( strcmp( szItem, DDE_ACLITEM )  == 0 ) return DDE_ACL;
if( strcmp( szItem, DDE_PLCITEM )  == 0 ) return DDE_PLC;
if( strcmp( szItem, DDE_CNCITEM )  == 0 ) return DDE_CNC;
if( strcmp( szItem, DDE_RVPITEM )  == 0 ) return DDE_RVP;
if( strcmp( szItem, DDE_LSMITEM )  == 0 ) return DDE_LSM;
if( strcmp( szItem, DDE_ASRSITEM ) == 0 ) return DDE_ASRS;
return DDE_CIM;
}

//-------------------------------------------------------------------
// void DeleteFiles( char *s )
//-------------------------------------------------------------------
void DeleteFiles( char *s )
{
//struct ffblk ffblk;
struct _finddata_t  ffblk;
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];
int done;

fnsplit(s, drive, dir, file, ext );
if( ( done = _findfirst( s, &ffblk) ) != -1) return;
sprintf( s, "%s%s%s", drive, dir, ffblk.name );
unlink( s );
while( !done )
	{
	done = _findnext(done, &ffblk );
	sprintf( s, "%s%s%s", drive, dir, ffblk.name );
	unlink( s );
	}
}


//-------------------------------------------------------------------
// int OPENCIMGetPrivateProfileString()
//-------------------------------------------------------------------
int OPENCIMGetPrivateProfileString(
	LPCSTR lpszSection,	   // address of section
	LPCSTR lpszEntry,	      // address of entry
	LPCSTR lpszDefault,	   // address of default string
	LPSTR lpszReturnBuffer,	// address of destination buffer
	int cbReturnBuffer,	   // size of destination buffer
	LPCSTR lpszFilename )	// address of initialization filename
{
char szTempFilename[MAXPATH];
char lpszReturnBufferEx[MAXPATH];
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];

// first we try to find our entry in our ini file
if( !GetPrivateProfileString( lpszSection, lpszEntry, lpszDefault,
										lpszReturnBuffer, cbReturnBuffer,
										lpszFilename ) ) {
// not found, let us know about OPENCIM.INI in our current ini
	if( !GetPrivateProfileString( /*NETWORKING*/
											OPENCIMINIGENERAL,
											SETUPPATH, lpszDefault,
											lpszReturnBufferEx, MAXPATH,
											lpszFilename ) ) {
// not found, let us know about our entry from default OPENCIM.INI
		if( !GetPrivateProfileString( lpszSection, lpszEntry, lpszDefault,
												lpszReturnBuffer, cbReturnBuffer,
												OPENCIMDEFAULTPATH ) ) return 0;
		}
// we know about OPENCIM.INI in our current ini file
// let us try to find our entry in it
	else { fnsplit( lpszReturnBufferEx, drive, dir, file, ext );
			 fnmerge( szTempFilename, drive, dir, OPENCIMINIFILE,
						 OPENCIMINIEXT );
			 GetPrivateProfileString( lpszSection, lpszEntry, lpszDefault,
											  lpszReturnBuffer, cbReturnBuffer,
											  szTempFilename);
		}
	}
return strlen ( lpszReturnBuffer );
}

//-------------------------------------------------------------------
// void FileAbort()
//-------------------------------------------------------------------
void FileAbort( char *szFile, char *szWarn )
{
//struct ffblk ff;
struct _finddata_t ff;

char szBuffer[256];

sprintf( szBuffer,
			"Fatal error. File not found. \n%s\n %s",
			 szFile, szWarn );
  if( _findfirst( szFile, &ff)==-1){//, FA_NORMAL ) )
    ::MessageBox(NULL,  szBuffer, "", MB_OK );
    exit(1);
	}
}

//--------------------------------------------------------------------
// char *PathTrunc (const char *path,int lenght)
//--------------------------------------------------------------------
char *PathTrunc (const char *path,int lenght)
{
static char buff[MAXPATH];
char 	    *ptr;

if ((int)strlen(path)<=lenght)
{	strcpy(buff,path);
	return buff;
}

strncpy(buff,(char *)path,3);	 
buff[strlen(buff)+1]='\0';
strcat(buff,"...");

ptr=(char *)path+2;
do
{	++ptr;
	ptr=strchr(ptr,'\\');
}
while ((int)strlen(ptr)>=lenght-7);
strcat(buff,ptr);
return buff;
}

void _strncpy (char *dest,char *src,int maxlen)
{
strncpy(dest,src,maxlen);
dest[maxlen]=0;
}

//-------------------------------------------------------------------
// char * SetDefaultExt()
//-------------------------------------------------------------------
char * SetDefaultExt( char *szFilePath, char *szExt )
{
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];

fnsplit( szFilePath, drive, dir, file, ext );
if( !ext[0] )
	strcat( szFilePath, szExt );
return szFilePath;
}


/*VCMM
FARPROC RetrieveFunc( LPSTR szModule, WORD nOrdinal,
							 LPSTR szName )
{
HANDLE hModule;
if( ( hModule = GetModuleHandle( szModule ) ) == 0 )
	if( ( hModule = LoadLibrary( szModule ) )
						< HINSTANCE_ERROR )
	return NULL;
	if( nOrdinal )	{
		FARPROC retval =
		GetProcAddress( ( HINSTANCE ) hModule,
		LPSTR( MAKELONG( nOrdinal, 0 ) ) );
	if( retval &&
		( !szName || GetProcAddress( ( HINSTANCE )hModule, szName )
												== retval )
		) return retval;
	else return 0;
	}
	else{
		if( szName ) return GetProcAddress(( HINSTANCE )hModule, szName );
		else return 0;
	}
}
*/

//----------------------------------------------------------------------------
// void WinSleep( int32 iNSec )
//----------------------------------------------------------------------------
void WinSleep( int iNSec )
{
long nFirst = time( NULL );
MSG msg;

while( nFirst + iNSec > time( NULL ) ) {
	/* Process waiting messages now */
	if( PeekMessage( &msg, NULL, NULL, NULL, PM_NOREMOVE ) ) {
		if( GetMessage( &msg, NULL, NULL, NULL ) ) {
			TranslateMessage( &msg );    /* Translates virtual key codes */
			DispatchMessage( &msg );     /* Dispatches message to window */
			}
		}
	}
}

//----------------------------------------------------------------------------
// void WinSleepYield( int32 iNSec )
//----------------------------------------------------------------------------
void WinSleepYield( int iNSec )
{
long nFirst = time( NULL );
while( nFirst + iNSec > time( NULL ) ) Yield();
}



void fnmerge(char *szCimSetupPath,char* drive, char* dir, 
						 char*file, char* ext ){
   strcpy(szCimSetupPath,drive);
	 strcat(szCimSetupPath,dir);
	 strcat(szCimSetupPath,file);
	 strcat(szCimSetupPath,ext);
}


void fnsplit(char *szCimSetupPath,char* drive, char* dir, 
						 char*file, char* ext ){
  UINT index=0;
	UINT prevpos;
	UINT slashpos1=0;
	UINT slashpos2=0;  
  UINT i; 


	drive[0]='.';
  drive[1]='.';
	drive[2]='\0';
  dir[0]='\0';
  file[0]='\0';
	ext[0]='\0';

	UINT len=strlen(szCimSetupPath);
  prevpos=len; 

	if (len>1 && szCimSetupPath[1]==':'){
    drive[0]=szCimSetupPath[0];
		index++;
    drive[1]=':';
		index++;
    drive[index]='\0';
	}	
	
  
  //index=1;
  while(index<len){
    if(szCimSetupPath[index]=='\\'){     
			if (slashpos1==0)
        slashpos1=index;
			else
				slashpos2=index+1;
    }

    if (szCimSetupPath[index]=='.'){     
      prevpos=index;//or +1
			for (i=slashpos2;i<prevpos;i++)
        file[i-slashpos2]=szCimSetupPath[i];
			file[i-slashpos2]='\0';
		}
		index++;
	}


	//for(i=0;i<strlen(drive);i++)
	//	dir[i]=drive[i];
	for (i=slashpos1;i<slashpos2;i++)
    dir[i-slashpos1/*+strlen(drive)*/]=szCimSetupPath[i];
  dir[i-slashpos1/*+strlen(drive)*/]='\0';

	for (i=prevpos;i<len;i++)
    ext[i-prevpos]=szCimSetupPath[i];
  ext[i-prevpos]='\0';
   
}
