// File: Vc2_typs.h          Modified by Shimon.   Date: 09-NOV-2004

//#include "\soft\extern\vc2_cmmn.h"  // for NETBIOS_NAME_LENGTH
//#include "\soft\extern\vc2_ncb.h"  // for NETBIOS NCB
//-------------------------------------------------------------------------
// (C) ESHED ROBOTEC (1982) LTD.
//
//
// Written & designed by Dimo L. Vasilenko   
// Created 04.04.94
//
// VC2_TYPS.H
//-------------------------------------------------------------------------
#ifndef __VC2_TYPS_H
#define __VC2_TYPS_H


#include <memory.h>
#include "vc2_ncb.h"
#include "vc2_typs.h"




//--- Debug section in VC2.INI ------
#define 	VC2_PROTOCOL           "VC2.PRT"
#define 	VC2_ACLPROTOCOL		  "$ACL_"
#define 	VC2_ACLPROTOCOLFLUSH	  "ACL_"
#define 	DEBUGGING              "Debug"
#define 	DEBUG_PROTOCOL         "Protocol"

//--- NetWorking String Names Definitions ---
#define 	SETUPPATH            "CimSetupPath"
#define 	MAX_NB_AR  	60    	 // NetBIOS appearance rate in seconds
#define 	NET_NUM_CLIENTS		"NumClients"
#define 	NETWORKING      		"Networking"
#define 	NET_STATUS      		"WorkStationState"
#define 	NET_SERVER_STATUS    "SERVER"
#define 	NET_CLIENT_STATUS    "CLIENT"
#define 	NET_SERVER_NAME      "ServerName"
#define 	NET_CLIENT_NAME      "ClientName"

#define 	DDE_COMMENT_OFFSET	35
#define 	VC2_ACLICON				60
#define 	VC2_DDEICON				61


#define PNP_DEVICENUMBER      "PNP_DevNumber"
#define PNP_DEVICE            "PNP_Device"

#define VC2_CONFIG 				"VC2.INI"
#define EXT_MAILSLOTMARKER 	".MSS"
#define 	NETWORKING      		"Networking"
#define 	SETUPPATH      		"CimSetupPath"
#define 	SETUPDIR      		   "CimSetupDir"
#define 	OPENCIMDEFAULTPATH   "\\OPENCIM\\SETUP\\OPENCIM.INI"
#define 	OPENCIMINIGENERAL    "General"
#define 	OPENCIMINIFILE       "OPENCIM"
#define 	OPENCIMINIEXT        ".INI"

#define  Daddy 					((CRemotecontrolApp*)AfxGetApp( ))


//--- colors definitions
//#define MAINWINDOWBKGNDCOLORS "MainWindowBkgndColors"
//#define MAINWINDOWTEXTCOLORS  "MainWindowTextColors"
//#define BACKGROUND RGB( cBkgndRed, cBkgndGreen, cBkgndBlue )
//#define FOREGROUND RGB( cTextRed, cTextGreen, cTextBlue )


// position name length
#define POSNAMELEN 33

#define MAXLENNAME              6
#define TOTALINOUTS     16
#define TOTALENCAXES    12
#define TOTALROBAXES    5
#define CMNDLEN         30

//#define MAX_LOGICALIDOFDEVICE   10
//#define LOGICAL_NO_ID                           -1

// definition of data types of controler data and item strings
// for getting the data from the DDE

// kind of messages receving from controler
typedef enum { Inputs, Outputs, Encoders, Xyzs, None }  MsgKind;
// type definitions for data received from controler
typedef BYTE    InOutValType;
typedef long    EncValType;
typedef double  XyzValType;
typedef InOutValType   InOutArrType[TOTALINOUTS];
typedef EncValType     EncArrType  [TOTALENCAXES];
typedef XyzValType     XyzArrType  [TOTALROBAXES];
// vals types
typedef enum {XyzVals, JntsVals}  PosValsType;
// position types
typedef enum {Absolute, RelToPos, RelToCurr, Vector}  PosType;
// position axes
typedef enum {Rob, Periph, Both}  PosAxes;
// position belongeness
typedef enum {Acl, Scorbase, All}  PosBelng;
// a general point union
typedef union {
                 EncArrType  EncVals;
                 XyzArrType  XyzVals;
} GenPnt;
// position data structure
typedef struct  {
        char     Name[POSNAMELEN];
        char     RelToPos[POSNAMELEN];
        PosValsType ValsType;
        PosType  Type;
        PosAxes  Axes;
        PosBelng Belng;
        GenPnt   Pnt;
//   EncArrType ValAxes;
} PosStruct;

//------ Add-In by Dimo L. Vasilenko ------------------------------
typedef struct  {
	BOOL echo;              // ADI NEW DDE
	long  taskID;            // adi send
	int  parametrCount;     // adi send
	char programName[6];    // adi send
	char parameters[60];    // "1,2,3,4"  // adi send
	float result;           // %END 33 VALUE result=atof(VALUE) // dimo sent
	int ObjectID;
	int startRefObjectID;
	int endRefObjectID;
	int time;
// new features (i have to add it to list!!!!!)
// int equipmentID;
} CimSomCPStruct;

typedef struct  {
        int ObjectID;
        int MoveTo;
        long h;             // hundredths of seconds
        BOOL Start;
} CimSomCPStructOLMTrack;

class  SOMParItemClass
{
public:
long  taskId;
char parameter[10];

SOMParItemClass( long aTaskId, char *aParameter )
        { taskId = aTaskId; strcpy( parameter, aParameter ); }

SOMParItemClass() { taskId = -1; parameter[0]='\0'; }

int IsEqual( SOMParItemClass *p )
		  {
		  return( p->taskId == taskId && !strcmp( p->parameter, parameter) );
		  }
};

class  SOMPrgItemClass
{
public:
long  taskId;
int  parametrCount;
char prg[6];

SOMPrgItemClass( long aTaskId, int aParametrCount, char *aPrg )
        { taskId = aTaskId; parametrCount = aParametrCount; strcpy( prg, aPrg ); }

SOMPrgItemClass() { taskId = -1; parametrCount = 0; prg[0]='\0'; }

int IsEqual( SOMPrgItemClass *p )
        {
        return( p->taskId == taskId              &&
                p->parametrCount == parametrCount &&
								  !strcmp( p->prg, prg ) );
		  }
};

class  ACLCommandStringsItemClass
{
public:
char prg[32];

ACLCommandStringsItemClass( char *aPrg )
{ strcpy( prg, aPrg ); }

ACLCommandStringsItemClass()
{ prg[0]='\0'; }

int IsEqual( ACLCommandStringsItemClass *p )
	{ return !strcmp( p->prg, prg ); }
};



class  SOM_PLC_ItemClass
{
public:
char prg[8];

SOM_PLC_ItemClass( char *aPrg ) { strcpy( prg, aPrg ); }

SOM_PLC_ItemClass() { prg[0]='\0'; }

int IsEqual( SOM_PLC_ItemClass *p )
        { return( !strcmp( p->prg, prg ) ); }
};

class  SOMMovieItemClass
{
public:

int  taskID;
int ObjectID;
int startRefObjectID;
int endRefObjectID;

SOMMovieItemClass( int  ataskID, int aObjectID,
                        int astartRefObjectID, int aendRefObjectID )
        {
        taskID = ataskID;
        ObjectID = aObjectID;
        startRefObjectID = astartRefObjectID;
        endRefObjectID = aendRefObjectID;
        }

SOMMovieItemClass()
        {
        taskID = ObjectID = startRefObjectID = endRefObjectID = 0;
        }

int IsEqual( SOMMovieItemClass *p )
        {
        return( p->taskID == taskID &&
                p->ObjectID == ObjectID &&
                p->startRefObjectID == startRefObjectID &&
                p->endRefObjectID == endRefObjectID );
        }
};

typedef struct  { int StationNumber;
                  int ErrorStatus;
                  long h;             // hundredths of seconds
                } PalleteReleaseStruct;

typedef struct  { int StationNumber;
                  int PalleteID;
                  long h;             // hundredths of seconds
                } PalleteArriveStruct;

typedef struct
        {
        BOOL ok;
        int SomeThing;
        long h;                             // hundredths of seconds
        } SOMIniStruct;

typedef struct
        { BOOL ok;
        int SomeThing;
        long h;                             // hundredths of seconds
        } SOMDownStruct;

const int MAX_SCANOBJECT = 20; // ? max numbers of scaned objects

typedef struct
{
UINT            uNum;      // numbers of scaned objects
UINT    uTypes;    // numbers types of scaned objects
int             iStatus;   // scan status
// set of counts & types of scaned objects ( count/type )
int             iScanObjects[MAX_SCANOBJECT][2];
} CIMRVScanStruct;


enum SOM_Material_Type { Unknown=0, Steel=1, Aluminum=2, Plastic=3 };

typedef struct
{
SOM_Material_Type type;
} SOM_SensorStruct;

typedef struct { char ObjectName[24]; //start...end...move
                 char ObjectType[9];
                 int ObjectID;
                 int RefObjectPos;
                 int RefObjectID;
                 long h;             // hundredths of seconds
                 int NextRefObjectPos;
                 int NextRefObjectID;
		 int MyPalletID;	
		 int ObjectCapacity;
                 } SOMObjectDataStruct;

typedef struct { long h; } RealTime;  // hundredths of seconds

typedef struct {
                         int bc;
                         long h; // hundredths of seconds
                         } SH_BarCodeStruct; // SHMULIK

typedef struct {
                BOOL Stranger;
                BOOL GDI_End;
                } GDI_EndStruct;  // GDI End

//--- end ---

// types of data passed through the DDE to the controler (commands)

typedef struct { int  sp;               } SetSpeedDDEType;
typedef struct { char prog[MAXLENNAME]; } AbortProgDDEType;
typedef struct { int  perc;             } JawDDEType;
typedef struct { char prog[MAXLENNAME]; } RunProgDDEType;
typedef struct { int  input,state;      } SetInputDDEType;
typedef struct { int  output,state;     } SetOutputDDEType;
typedef struct { int  ax,direc,kind;    } EnterManDDEType;
typedef struct { int  op;               } HomeDDEType;
typedef struct { int  ax,state;         } ConCoffDDEType;
typedef struct { char Name[POSNAMELEN];
                                          int SpeedTime, Flag;   } MoveJDDEType;
typedef struct { char Name[POSNAMELEN];
                                          int SpeedTime, Flag;   } MoveLDDEType;
typedef struct { char Name[POSNAMELEN],
                                          ThName[POSNAMELEN];
                                          int SpeedTime, Flag;   } MoveCDDEType;
typedef struct { int  EncAxesNum,
                                          GripperAxe;                            } RobotTypeDDEType;
typedef                         PosStruct                                               PosDataDDEType;
// ---- by Dimo
typedef CimSomCPStruct                          CimSomCPDataDDEType;
typedef CimSomCPStructOLMTrack          CimSomCPOLMTrackDataDDEType;
typedef PalleteReleaseStruct            PalleteReleaseDataDDEType;
typedef PalleteArriveStruct             PalleteArriveDataDDEType;
typedef SOMIniStruct                                    SOMIniDataDDEType;
typedef SOMDownStruct                           SOMDownDataDDEType;
typedef SOM_SensorStruct                SOM_SensorDataDDEType;
typedef SOMObjectDataStruct             SOMObjectNameInquireQDataDDEType;
typedef SOMObjectDataStruct             SOMObjectNameInquireADataDDEType;
typedef SOMObjectDataStruct             SOMObjectCreateQDataDDEType;
typedef SOMObjectDataStruct             SOMObjectCreateADataDDEType;
typedef SOMObjectDataStruct             SOMObjectDeleteQDataDDEType;
typedef SOMObjectDataStruct             SOMObjectConnectQDataDDEType;
typedef RealTime                                RealTimeDataDDEType;
typedef SOMObjectDataStruct      SH_CloseDataDDEType;
typedef SOMObjectDataStruct      SH_OpenDataDDEType;
typedef CimSomCPStructOLMTrack   SH_ArriveDataDDEType;
typedef SH_BarCodeStruct                SH_BarCodeDataDDEType;
typedef GDI_EndStruct           GDI_EndDataDDEType;

// position class
class PosClass
{
        char     Name[POSNAMELEN];
        PosValsType ValsType;  // XyzEncs;
        PosType  Type;
        PosAxes  Axes;
        PosBelng Belng;
        char     RelToPos[POSNAMELEN];
public:
        GenPnt   Pnt;
        PosClass(){}
        PosClass(char *name)  {  strcpy(Name, name); }
        PosClass(char *name, PosType t, PosAxes a, PosBelng b, PosValsType vt, char *rel)
         {
                 strcpy(Name, name);
                 strcpy(RelToPos, rel);
                 Type = t;
                 Axes = a;
                 Belng = b;
                 ValsType = vt;
         }
        void        SetName(char *name)    { strcpy(Name, name); }
        void        SetRelName(char *name) { strcpy(RelToPos, name); }
        void        SetType(PosType type)  { Type = type; }
        void        SetAxes(PosAxes axes)  { Axes = axes; }
        void        SetBelng(PosBelng bel) { Belng = bel; }
        void        SetValsType(PosValsType pt) { ValsType = pt; }
        int         IsEqual(PosClass *p)   { return(!strcmp(p->Name, Name)); }
        void        GetName(char *name)    { strcpy(name, Name); }
        void        GetRelName(char *name) { strcpy(name, RelToPos); }
        PosType     GetType()              { return(Type); }
        PosValsType GetValsType()          { return(ValsType); }
        PosAxes     GetAxes()              { return(Axes); }
        PosBelng    GetBelng()             { return(Belng); }
};

// a command data type (class) which consists the command queue
class CmndData
{
public:
        char   szCmnd[CMNDLEN];
        CmndData()
        {}

        CmndData(char *cmd)    {  strcpy(szCmnd, cmd); }
        int IsEqual(CmndData *Cmd) {  return(!strcmp(szCmnd, Cmd->szCmnd)); }
};


//------------------ CIM NETBIOS STRUCTURES ------------------------
class  CIM_NetBIOSClientItemClass
{
public:
char chClientName[NETBIOS_NAME_LENGTH+1];// Client name
BYTE bLsnClient;                         // Client Local Session Number
int  iRefRate;                           // Refresh rate in second
long lLastAppearence;  // last time of "i'm free" request
long lWhenConnected;
BOOL bStandBy;         // Registered & StandingBy
int  iPassingCount;     // counter for passing the client by if no Msg
int  iPassingStore;     // counter to save history of  passing
int  iItemsInQueue;

CIM_NetBIOSClientItemClass( char *AchClientName, BYTE AbLsnClient )
        {
        strcpy( chClientName, AchClientName );
        bLsnClient = AbLsnClient;
        lWhenConnected = lLastAppearence = iRefRate = 0;
        bStandBy = TRUE; // if i create it's stand by
        iPassingCount = 0;
        iItemsInQueue = 0;
        iPassingStore = 0;
        }

CIM_NetBIOSClientItemClass()
        {
        chClientName[0] = '\0';
        bLsnClient = 0;
        lWhenConnected = lLastAppearence = iRefRate = 0;
        bStandBy = FALSE; // if i make dummy reference it's not stand by
        iPassingCount = 0;
        iItemsInQueue = 0;
        iPassingStore = 0;
        }

int IsEqual( CIM_NetBIOSClientItemClass *p )
        {
        return( !strcmp( p->chClientName, chClientName ) );
        }
};


class  CIM_NetBIOSSTBSItemClass   // strings to be send
{
public:
	BYTE bMsgToBeSent[512];  // message
	BYTE bLsn;                               // Local Session Number

	CIM_NetBIOSSTBSItemClass( BYTE *aMsg, BYTE AbLsn ){
		memcpy( bMsgToBeSent, aMsg, 512 );
		bLsn = AbLsn;
	}

	CIM_NetBIOSSTBSItemClass(){
		memset( &bMsgToBeSent, 0, 512 );
		bLsn = 0;
	}

	int IsEqual( CIM_NetBIOSSTBSItemClass *p ){
		return( !memcmp( p->bMsgToBeSent, bMsgToBeSent, 512 ) &&
                          p->bLsn == bLsn );
	}
};

typedef enum WorkStationState { NCB_Client = 1, NCB_Server };

typedef enum _MyClientStates { C_ISFREE = 1, C_READFILE, C_WAITING
                                                                          } MyClientStates;

typedef struct StringAndFlagT {
	char *s; long f; 
}StringAndFlag;


typedef struct ACL_PostFunctionT { 
	char *prg; unsigned int msg; 
}ACL_PostFunction;

typedef struct InputMessagePrefixDispatcherT { 
	char *sp; int iMsg; 
}InputMessagePrefixDispatcher;

typedef enum IsWaitingStateT { Start=1, Yes, No }IsWaitingState;



// this is the COPY of NCB structure from WorkStation
class  CIM_NetBIOSServerInPutMsgItemClass
{
public:
BYTE bMsg[sizeof(NCB)];

CIM_NetBIOSServerInPutMsgItemClass( BYTE *aMsg )
        {
        memcpy( bMsg, aMsg, sizeof( NCB ) );
        }

CIM_NetBIOSServerInPutMsgItemClass() {}

int IsEqual( CIM_NetBIOSServerInPutMsgItemClass *p )
        { return(!memcmp( p->bMsg, bMsg, sizeof(NCB) ) ); }

};

typedef enum tag_WhatServerQueFrom
        { FromServerNonQue = 0, FromServerHighQue };


//--------- DDE New Technology -------------------------------------



class  CIM_NT_DDEMsgItemClass
{
public:
BYTE bMsg[512];

CIM_NT_DDEMsgItemClass( BYTE *aMsg )
        { memcpy( bMsg, aMsg, sizeof(BYTE)*512 ); }

CIM_NT_DDEMsgItemClass()
        { memset( bMsg, 0, sizeof(BYTE)*512 ); }

int IsEqual( CIM_NT_DDEMsgItemClass *p )
        // by ID of Msg
        // keep in mind also
        // that offset to LONG ID of Message equals 38 BYTE
        { return(!memcmp( (p->bMsg)+38, (bMsg+38), sizeof(LONG) ) ); }
};

class CIM_NT_DDE_RTableItemClass{
public:
WORD            wIdOfWM_OfMine;                // My input WM_

BYTE    szNameOfWorkStation[16]; // name of Receiver WS
BYTE    szNameOfDDEItem[16];     // name of Receiver  DDE Item
WORD            wIdOfWM_;                // WM_ of this data for Receiver
BYTE    bIdOfDevice;             // ID of phisical device Receiver

CIM_NT_DDE_RTableItemClass( WORD        aIdOfWM_OfMine,
									 BYTE*          aNameOfWorkStation,
									 BYTE*          aNameOfDDEItem,
									 WORD           aIdOfWM_,
									 BYTE   aIdOfDevice )
		  {
		  wIdOfWM_OfMine = aIdOfWM_OfMine;
		  strcpy( (char*)szNameOfWorkStation, (char*)aNameOfWorkStation );
		  strcpy( (char*)szNameOfDDEItem, (char*)aNameOfDDEItem );
		  wIdOfWM_        = aIdOfWM_;
		  bIdOfDevice = aIdOfDevice;
		  }

CIM_NT_DDE_RTableItemClass()
		  {
		  wIdOfWM_OfMine = 0;
		  szNameOfWorkStation[0]='\0';
		  szNameOfDDEItem[0]='\0';
		  wIdOfWM_ = 0;
		  bIdOfDevice = 0;
		  }

int IsEqual( CIM_NT_DDE_RTableItemClass *p )
		  {
		  return(  wIdOfWM_OfMine == p->wIdOfWM_OfMine &&
								  !strcmp((char*)szNameOfWorkStation, (char*)p->szNameOfWorkStation ) &&
								  !strcmp((char*)szNameOfDDEItem, (char*)p->szNameOfDDEItem ) &&
                                wIdOfWM_ == p->wIdOfWM_ &&
                                bIdOfDevice == p->bIdOfDevice );
        }
};

//typedef struct { WORD wWM_OfMine;      // The structure to be used
//                 VOID *vPOfData;       // to pass data from equipment
//                 WORD wSizeOfData;     // message level to OutPutDDE
//                 BOOL bIsServerPassed; // message level to OutPutDDE
//               } NDDEDataToBePassed; // Queue


typedef struct { int iData1;
                 int iData2;
                 long h;
                 WORD wIdOfDevice; }    CimPLCStruct;

typedef struct {        long iTaskID;
                                                int iPartID;
                                                int iFromToID;
                                                int iFromToIndx;
                                        } CimOLMTMoveToStruct;

typedef struct {        BYTE bLsn;  // local session number of network client
                                                int iNMsg;  // Number of Msg in its Network queue
                                        } NetLsnAndNMsg;



//-------------------------------------------------------------------
// CNC Information interchange item Class
class  CIM_CNCMsgItemClass
{
public:
int     iWM_InputExt;        // external WM_ from CIM
char    szValueInput[17];    // mask for Input
int     iWM_InputInt;        // internal Input
int     iWM_OutputExt;       // external WM_ to CIM
char    szValueOutput[17];   // mask for Output
int     iWM_OutputInt;       // external Input

CIM_CNCMsgItemClass( int     aWM_InputExt,
							char    *aValueInput,
							int     aWM_InputInt,
							int     aWM_OutputExt,
							char    *aValueOutput,
							int     aWM_OutputInt )
		  {
		  iWM_InputExt = aWM_InputExt;
		  strcpy( szValueInput, aValueInput );
		  iWM_InputInt = aWM_InputInt;
		  iWM_OutputExt = aWM_OutputExt;
		  strcpy( szValueOutput, aValueOutput );
		  iWM_OutputInt = aWM_OutputInt;
		  }

CIM_CNCMsgItemClass()
		  {
		  iWM_InputExt = 0;
		  szValueInput[0] = 0;
		  iWM_InputInt = 0;
		  iWM_OutputExt = 0;
		  szValueOutput[0] = 0;
		  iWM_OutputInt = 0;
		  }

int IsEqual( CIM_CNCMsgItemClass *p )
		  { return( iWM_InputExt == p->iWM_InputExt ); }
};

typedef struct {  char szDDEChannel[16];
						BYTE bIdOfDevice;
						BOOL bIsOpen;
						BOOL bIsEcho;
						BOOL bStandBy;  }       CimDDEChannelsStatStruct;

typedef struct {  int  iErrorValue;
						int  iACLTaskID;
						int  iLine;
						char szStr[80];
						char szACLProgramName[32]; }     CimACLErrorStruct;

typedef CimACLErrorStruct  CimErrorStruct;

typedef struct {  BOOL bImmediately;
						char cmd[32];           }  CimACLCommandStruct;

typedef struct {  BOOL bPrior;
						char szWorkStation[16];
						char szDDEChannel[16]; }   CimCloseUnitsStruct;

typedef struct {  char szWorkStation[16];
						char szDDEChannel[16];
						BYTE bIdOfDevice; } 			CimWorkStationStruct;

typedef struct {
					char szRequest[32];
					char szArgv[32];
					} CimCNCRequestStruct;


typedef enum { Red, Yellow, Green } DDESemaphore;



typedef struct {
					WORD Msg;            // message
					CimPLCStruct data;   // data
					} CimPLCMsgStruct;

typedef struct {
					char s[128];
					} CIMSendStringStruct;

#define MAXPLCEVENTS    25

typedef struct {
					int iCount;             			 // counter
					CimPLCMsgStruct Ev[MAXPLCEVENTS]; // plc event
					} CimPLCComplexStruct;

// The definitions below are used in CNC_DLL interface
// Any changes forbidden

#define CNC_RECMAXSIZE 32
#define CNC_ACTMAXSIZE 64
#define CNC_ARGVMAXSIZE 32


typedef struct {
					int 	iStringNumber;
					char 	szRequest[CNC_RECMAXSIZE+1];
					char 	szAction[CNC_ACTMAXSIZE+1];
					int 	iReturn;
					} CimCNCStruct;

typedef int (*pFunction)(void*);

typedef struct {
					int argc;
					char argv[8][CNC_ARGVMAXSIZE+1];
					} CNCLintFuncArgv;

class  CimCNCLanguageItemClass
{
public:
CimCNCStruct data;
pFunction Function;
pFunction Comparison;
CNCLintFuncArgv Argv;

CimCNCLanguageItemClass( CimCNCStruct p )
	{
	data.iStringNumber = p.iStringNumber;
	strcpy( data.szRequest, p.szRequest );
	strcpy( data.szAction, p.szAction );
	data.iReturn = p.iReturn;
	}

CimCNCLanguageItemClass()
	{
	data.iStringNumber = 0;
	data.szRequest[0] = '\0';
	data.szAction[0] = '\0';
	data.iReturn = 0;
	}

int IsEqual( CimCNCLanguageItemClass *p )
		  {
		  /*
		  return( data.iStringNumber == p->data.iStringNumber    &&
					!strcmp( data.szRequest, p->data.szRequest ) 	&&
					!strcmp( data.szAction, p->data.szAction )		&&
								data.iReturn == p->data.iReturn );
		  */
		  return( data.iStringNumber == p->data.iStringNumber );
		  }
};

// The upper definitions  are used in CNC_DLL interface
// Any changes forbidden

typedef enum
	{
	L_FastASleep = 0,                // run new action if there is
	L_Doing,            					// wait for result
	L_OperationCompletedRightAway,   // send result if available
	L_OperationCompletedWithAnError, // send error if available
	} CNCLint_State;

typedef enum { NoClose, CloseAll, CloseLocal  } eCloseMode;

typedef struct {
					float fValue;
					} CimLSMStruct;

typedef struct {
					BYTE szWorkStationSender[16];
					BYTE szDDEChannelSender[16];
					BYTE aIdOfDeviceSender;
					LONG aIdOfMessage;
					} CimMessageHistoryStruct;

typedef struct
	{
		int  iRequest;
		char szRequest[6];
		BOOL bRescan;
		float fLow;
		float fHigh;
		float fResult;
		BOOL bInRange;
		int iPartId;
		char szPartName[20];
	} CimQCStruct;


typedef enum tagCimInitState
	{
	CIMINIT_START = 0, CIMINIT_SEND, CIMINIT_END
	};

typedef struct
	{
	BYTE    szNameOfWorkStation[16];
	BYTE    szNameOfDDEItem[16];
	BYTE    bIdOfDevice;
	} CimDeviceStruct;


class CimInitItem
{
public:

BYTE    szNameOfWorkStation[16]; // name of Receiver WS
BYTE    szNameOfDDEItem[16];     // name of Receiver  DDE Item
BYTE    bIdOfDevice;             // ID of phisical device Receiver
BOOL 	  bIsReady;

CimInitItem( BYTE    *NameOfWorkStation,
				 BYTE    *NameOfDDEItem,
				 BYTE    IdOfDevice,
				 BOOL 	IsReady )
	{
	strcpy( (char*)szNameOfWorkStation, (char*)NameOfWorkStation );
	strcpy( (char*)szNameOfDDEItem, (char*)NameOfDDEItem );
	bIdOfDevice = IdOfDevice;
	bIsReady = IsReady;
	}
CimInitItem()
	{
	szNameOfWorkStation[0] = 0;
	szNameOfDDEItem[0] = 0;
	bIdOfDevice = 0;
	bIsReady = FALSE;
	}
int IsEqual( CimInitItem *p )
		  {
		  return( p->bIdOfDevice == bIdOfDevice &&
		  !strcmp( (char*)p->szNameOfWorkStation, (char*)szNameOfWorkStation ) &&
		  !strcmp( (char*)p->szNameOfDDEItem, (char*)szNameOfDDEItem ) );
		  }
};

typedef struct { 	char szWSName[32];
						char szDeviceID[32];
						char szState[32];
					} TCimInitDialogStruct;


typedef struct { long lRecPos;
					  char szWSName[16];
					} CimASRSStruct;


//-------------------------------------------------------------------
// class CimACLMsg
//-------------------------------------------------------------------
class CimACLMsg
{
public:
CimSomCPStruct d;

CimACLMsg( CimSomCPStruct& a ) { d = a; }
CimACLMsg() { }
int IsEqual( CimACLMsg *p )
		  {
		  return( p->d.taskID == d.taskID &&
		  !strcmp( (char*)p->d.programName, (char*)d.programName ) &&
		  !strcmp( (char*)p->d.parameters, (char*)d.parameters ) );
		  }
};

typedef enum { OMRON, ALLENBRADLEY }tagPLCType;
// typedef enum { Run, Stop, Arrive, Release, Pass }  tagPalletStatus;   // Microsoft compiler bug

typedef enum 
{ 
	Run, 
	Stop1,            // Shimon 'Stop' is the correct value, but cause Internal compiler error.
	Arrive,
	Release,
	Pass 
}tagPalletStatus;

typedef struct
{
	tagPalletStatus Status;
	int iDest;
} tagCIMPallet;


typedef struct
	{
	CStringArray 	*p;
	BOOL 				bIs;     	// to be loaded
	BOOL 				bAsSlot;    // to be loaded as Slot
	BOOL 				bSafety;    // pass message to safety device
	char           szMailSlotMarkerDir[MAXDIR];
	char           szMailSlotMarkerName[MAXFILE+MAXEXT];
	} tagVC2_Loading;


typedef enum { Real, SimulAuto, SimulManual, Standalone, StandaloneOnly } ControlMode;

#endif // define VC2_TYPS_H
