// File: remote controlDlg.h                 Date: 01-DEC-2004
//

#include "communication_thread.h"
#include "communication_defs.h"
#include "PacketEditorDlg.h"
#include "DisplayWndDlg.h"
#include "WinSocket\mTie.h"

//{{AFX_INCLUDES()
#include "vsflexgrid.h"
#include "texttospeech.h"
//}}AFX_INCLUDES

#if !defined(AFX_REMOTECONTROLDLG_H__C6CCA9AA_4476_4440_85CF_319CCB14FB74__INCLUDED_)
#define AFX_REMOTECONTROLDLG_H__C6CCA9AA_4476_4440_85CF_319CCB14FB74__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "vector"
#include "algorithm"

using namespace std;

/*
 *  ===========================================================================
 *		Defines
 *  ===========================================================================
 */

#define ID_TIMER 1 
#define TIMER_ID_CIM 2

#define TIMER_INTERVAL_CIM 100



#define M_E             2.7182818284590452354   /* e */
#define M_LOG2E         1.4426950408889634074   /* log 2e */
#define M_LOG10E        0.43429448190325182765  /* log 10e */
#define M_LN2           0.69314718055994530942  /* log e2 */
#define M_LN10          2.30258509299404568402  /* log e10 */
#define M_PI            3.14159265358979323846  /* pi */
#define M_PI_2          1.57079632679489661923  /* pi/2 */
#define M_PI_4          0.78539816339744830962  /* pi/4 */
#define M_1_PI          0.31830988618379067154  /* 1/pi */
#define M_2_PI          0.63661977236758134308  /* 2/pi */
#define M_2_SQRTPI      1.12837916709551257390  /* 2/sqrt(pi) */
#define M_SQRT2         1.41421356237309504880  /* sqrt(2) */
#define M_SQRT1_2       0.70710678118654752440  /* 1/sqrt(2) */


const short sNO_TURN = 360;

const int ciMaxRows = 51;

const int ciColumnPosit = 1;
const int ciColumnSpeed = 2;

const char cszOnline[] = "Online";
const char cszSimulation[] = "Simulation";
const char cszStandalone[] = "Standalone";
const char cszANY[] = "ANY";
const char cszSetTheta[] = "Please set value of Theta and click on Set Home button again.";

const char cszVoiceSection[] = "voice_messages";
const char cszStatusSection[] = "status_messages";

struct Position
{
	long lNumber;
	long lX;
	long lY;
	short sTheta;
};


typedef vector< Position >VECT_POSIT;


struct GoToPosition
{
	long lNumber;
	byte uncSpeed;
};

typedef vector< GoToPosition >PATH_POSITS;

struct Path
{
	CString strName;
	PATH_POSITS PositArray;
};

typedef vector< Path >VECT_PATH;


struct ReceivedString
{
	long lCommandFromDevID;
	CString strString;
	CString strPathName;
};


/////////////////////////////////////////////////////////////////////////////
// CRemotecontrolDlg dialog

class CRemotecontrolDlg : public CDialog
{
// Construction
public:
	CRemotecontrolDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRemotecontrolDlg)
	enum { IDD = IDD_REMOTECONTROL_DIALOG };
	CButton	m_ByUser;
	CButton	m_Any;
	CButton	m_Automatic;
	CButton	m_Manual;
	CListBox	m_CIM_Messages_List;
	CComboBox	m_CIM_Modes;
	CStatic	m_StaticStatus;
	CComboBox	m_ComboPathName;
	CComboBox	m_ComboPositNumber;
	CComboBox	m_ComboSpeed;
	CButton	m_right_button;
	CButton	m_left_button;
	CButton	m_backward_button;
	CButton	m_forward_button;
	CButton	m_stop_button;
	CString	m_strDistance;
	CString	m_strTurnTo;
	CString	m_strEditX;
	CString	m_strEditY;
	CString	m_strEditTheta;
	CString	m_strTurn;
	CVSFlexGrid	m_ListPosit;
	CString	m_strUltraSoundThreshold;
	CTextToSpeech	m_Speaker;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRemotecontrolDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	LRESULT On_receive_packet(WPARAM wParam,LPARAM lParam);
	//{{AFX_MSG(CRemotecontrolDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void On_button_forward();
	afx_msg void On_button_left();
	afx_msg void On_button_stop();
	afx_msg void On_button_right();
	afx_msg void On_button_backward();
	afx_msg void On_set_communication_port();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSettingsPacketeditor();
	afx_msg void OnToolsDisplayWindow();
	afx_msg void OnAppAbout();
	afx_msg void OnButtonGo();
	afx_msg void OnButtonSetHome();
	afx_msg void OnButtonTurnTo();
	afx_msg void OnButtonClear();
	afx_msg void OnButtonTeach();
	afx_msg void OnButtonGoCartes();
	afx_msg void OnButtonTurn();
	afx_msg void OnButtonLocalize();
	afx_msg void OnButtonDeletePosit();
	afx_msg void OnOpenFile();
	afx_msg void OnSaveFile();
	afx_msg void OnSaveAsFile();
	afx_msg void OnExit();
	afx_msg void OnClose();
	afx_msg void OnCancel();
	afx_msg void OnButtonAddPath();
	afx_msg void OnButtonDeletePath();
	afx_msg void OnButtonGoAlong();
	afx_msg void OnButtonClearListPosit();
	afx_msg void OnSelchangeComboPositNumber();
	afx_msg void OnSelchangeComboPathName();
	afx_msg void OnButtonHoming();
	afx_msg void OnButtonPause();
	afx_msg void OnButtonContinue();
	afx_msg void OnSelchangeComboCimModes();
	afx_msg void OnRadioAuto();
	afx_msg void OnRadioManual();
	afx_msg void OnRadioByUser();
	afx_msg void OnRadioAny();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	LRESULT  AGVDriver_ReceivedString( WPARAM WParam, LPARAM LParam );
	LRESULT  AGVDriver_DrawLine( WPARAM, LPARAM LParam );

//functions
private:
#ifdef REMOTE_COMMANDS_DBG
	void Print_remote_commands();
#endif REMOTE_COMMANDS_DBG
	void Init_com_port(void);
	byte Check_sum(byte* packet,int length);
	void Analyze_packet(byte* packet);

	int GetComboIndexOfDDModes( int iMode );
	int GetDDMode();
	void OpenPathsFile( CString strPathsFile );

	void ListBoxAddString( LPCSTR lpszString );


public:
	void Transmit_packet(BOOL user_command=FALSE, byte packet_id=0);

//Attributes
private:

	HANDLE m_h_com;
	CComThread* m_p_com_thread;
	byte m_remote_keys_bitmap;//for representing the manual navigation keys that are pressed
	byte m_send_packet_id;//indicates the packet id we should send to the robot (if 0 then none)
	BOOL m_keyboard_nav_cntrl;//indicates if user is using keybord navigation control (control can be also received through the dialog box)
	short m_halt_communication_count;//indicates if we should halt he communication (if -1 then halting is disabled for 1 round and then set to 0)
	CDisplayWndDlg* m_disp_wnd_dlg;
	CPacketEditorDlg* m_packet_editor_dlg;
	byte m_drive_motor_cmnd_end_reason;        //the reason for ending the drive command
	byte m_ack_type;                           //type of RESEARCH_KIT_ROBOT_PC_ACK_ID message
	short m_last_comm_count;//represents the elapsed time since the last communication
#ifdef DEMO_MODE
	byte m_demo_mode_state;
#endif DEMO_MODE

    BOOL m_bIsRobotRespond;

    int m_iCloseCounter;

	BOOL m_bIsRobotRun;

	BOOL m_bIsGo;
	BOOL m_bIsTurnTo;
	BOOL m_bIsTurn;
	BOOL m_bIsGoCartes;
	BOOL m_bIsGoPath;
	BOOL m_bIsHoming;

	BOOL m_bIsCommandReceived;
	BOOL m_bIsCommandFinished;
	int m_iCommandFinishedDelayCounter;

	short m_sHeading; // Current status by angle 0-360 degrees.
	long m_lDistance; // Current status in cm.

	short m_sPrevHeading; // Previous status by angle 0-360 degrees.
	long  m_lPrevDistance; // Previous status in cm.

	short m_sHomeHeading; 
	long  m_lHomeDistance; 

	short m_sHeadingCorrection;

	long m_lStopDistanceCount;
	long m_lSquareSideCount;
	long m_lSquareSideLen;

	long m_lStopAngleCount;
	long m_lRequiredAngle;

    long  m_lFirstDistanceCount;
	short m_sFirstHeading;
    
	byte m_uncSpeed;

	long  m_lCurrentX;
	long  m_lCurrentY;
	short m_sCurrentTheta;

	long  m_lX_PositError;
	long  m_lY_PositError;
	short m_sTheta_PositError;

	long  m_lPrevX;
	long  m_lPrevY;
	short m_sPrevTheta;

    BOOL  m_bCartesGoForward;
	BOOL  m_bCartesTurn;
	BOOL  m_bCartesTheta;

	long  m_lCartesGoForward;
	short m_sCartesTurn;
	short m_sCartesTheta;

	DWORD m_dwTimerTick;
	DWORD m_dwLastReceivedDataTick;
	DWORD m_dwLastCmndReceivedAck;

	VECT_POSIT m_PositArray;

	VECT_PATH m_PathArray;

    PATH_POSITS CurrentPositArray;
	int m_iPositCounterAlong;

	BOOL m_bIsPathChanged;

	CString m_strPathFillFullName;

	int m_iHomingHeadingCounter;

	short m_sUltraSoundThreshold;

	int m_iRepeatMoveRobotCounter;
	BOOL m_bWasRepeatMoveRobot;

	BOOL  m_bEndProgramMode;

	BOOL m_bIsPause;

	BOOL m_bWasFalseBumperEvent;

    long m_lLastXCmnd;
	long m_lLastYCmnd;
	short m_sLastTheta;
	byte m_uncLastSpeed;

	TCHAR m_szExecDir[_MAX_PATH];
    CString m_strINIfilePath;

	int m_iDelayAfterObstacle_ms;
	CString m_strAppLanguageFilePath;
	
	CmTie  *pKnot;
	ReceivedString LastReceivedString;


	BOOL Executer();   // True if was Transmit command.
	void RequestForMotionInfo( BOOL bIsRequest = TRUE );
	void MoveRobot( byte uncMovementType = 2, byte uncSpeed = 19, short sHeading = 360, 
							unsigned short sDistance = 0, short sUltraSoundThreshold = 0 );

	void RepeatMoveRobot();
    void ClearMovementFlags();

	void GoToCartes( long lX, long lY, short sTheta, byte uncSpeed = 19 );
	void CalcCartesianCoor();
	void ViewCartesianCoor();
    void FillInGridPositCombo();

	void Localize();


	double Rad2Deg( double dbRadians ){ return 180.0 * dbRadians / M_PI; }
	double Deg2Rad ( double dbDegree ){ return M_PI * dbDegree / 180.0; }

	// Input:  CurrentPositArray, m_iPositCounterAlong
	void GoAlongPath();
	BOOL GetExecDir( TCHAR *pDir );

	BOOL Speaker( LPCSTR szKey, LPCSTR szDefaultText  = "" );

	BOOL AGVDriver_SendDesiredString( long lToDeviceID, CString &strString );
	BOOL IsValidCIM_Address( int iDeviceID, char *szWorkStation, char *szDDE );

	BOOL IsRobotMoved();

	BOOL PlayMP3( LPCSTR szFilePath );
	BOOL PlayFile( LPCSTR szFilePath );

public:
	//parameters from the CPacketEditorDlg dialog
	byte m_packet_editor_dlg_param1;
	byte m_packet_editor_dlg_param2;
	byte m_packet_editor_dlg_param3;
	byte m_packet_editor_dlg_param4;
	short m_packet_editor_dlg_param5;
	short m_packet_editor_dlg_param6;
	short m_packet_editor_dlg_param7;

//	CStatusBar m_StatusBar;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REMOTECONTROLDLG_H__C6CCA9AA_4476_4440_85CF_319CCB14FB74__INCLUDED_)
